FUNCTION(int, link, const char *, const char *)
FUNCTION(int, unlink, const char *)
FUNCTION(int, chown, const char *, uid_t, gid_t)
FUNCTION(int, chmod, const char *, mode_t)
FUNCTION(int, mknod, const char *, mode_t, dev_t)
FUNCTION(int, mkfifo, const char *, mode_t)
FUNCTION(int, rmdir, const char *)
FUNCTION(int, mkdir, const char *,  mode_t)
FUNCTION(int, rename, const char *, const char *)
FUNCTION(int, utimes, const char *, const struct timeval *)
FUNCTION(int, utime, const char *, const struct utimbuf *)

#if defined(HAVE_LUTIMES)
FUNCTION(int, lutimes, const char *, const struct timeval *)
#endif

/* at funcs */
#if defined(__EXTENSIONS__) || !defined(__XOPEN_OR_POSIX) ||	\
	defined(_ATFILE_SOURCE)
#if defined(HAVE_LINKAT)
FUNCTION(int, linkat, int, const char *, int, const char *, int)
#endif
FUNCTION(int, unlinkat, int, const char *, int)
#if defined(HAVE_SYMLINKAT)
FUNCTION(int, symlinkat, const char *, int, const char *)
#endif
#if defined(HAVE_READLINKAT)
FUNCTION(ssize_t, readlinkat, int, const char *, char *, size_t)
#endif
FUNCTION(int, fchownat, int, const char *, uid_t, gid_t, int)
#if defined(HAVE_MKNODAT)
FUNCTION(int, mknodat, int, const char *, mode_t, dev_t)
#endif
#if defined(HAVE_MKFIFOAT)
FUNCTION(int, mkfifoat, int, const char *, mode_t)
#endif
#if defined(HAVE_MKDIRAT)
FUNCTION(int, mkdirat, int, const char *, mode_t)
#endif
FUNCTION(int, renameat, int, const char *, int, const char *)
#endif

/* times at */
#if defined(__EXTENSIONS__) || \
        (!defined(_STRICT_STDC) && !defined(__XOPEN_OR_POSIX))
        /* || defined(_XPG7) */
FUNCTION(int, futimesat, int, const char *, const struct timeval *)
FUNCTION(int, utimensat, int, const char *, const struct timespec *, int)
#endif

/* lstat */
#if !defined(__XOPEN_OR_POSIX) || defined(_XPG_2) || defined(__EXTENSIONS__)
FUNCTION(int, symlink, const char *, const char *)
FUNCTION(ssize_t, readlink, const char *, char *, size_t)
FUNCTION(int, lchown, const char *, uid_t, gid_t)
#endif

/* mkstemp */
FUNCTION(char *, mktemp, char *)
FUNCTION(char *, mkdtemp, char *)

FUNCTION(DIR *, opendir, const char *)

/* linux */
#ifdef HAVE_FGETXATTR
FUNCTION(ssize_t, getxattr, const char *, const char *, void *, size_t)
FUNCTION(ssize_t, lgetxattr, const char *, const char *, void *, size_t)
FUNCTION(int, setxattr, const char *, const char *, const void *, size_t, int)
FUNCTION(int, lsetxattr, const char *, const char *, const void *, size_t, int)
#if defined(INTERPOSE_REAL)
FUNCTION(ssize_t, fgetxattr, int, const char *, void *, size_t)
FUNCTION(int, fsetxattr, int, const char *, const void *, size_t, int)
#endif
#endif

/* solaris legacy */
#ifdef HAVE__XSTAT
FUNCTION(int, _xstat, int, const char *, struct stat *)
#endif
#ifdef HAVE__LXSTAT
FUNCTION(int, _lxstat, int, const char *, struct stat *)
#endif

#if defined(INTERPOSE) && defined(TRACE)
FUNCTION(void *, dlopen, const char *, int mode)
#endif
